<template>
    <span>{{ hour }}:{{ minute }}:{{ second }} {{ timezone_label }}</span>
</template>

<script>
    import { mapGetters } from 'vuex';

	export default {
		props: ['tz'],
		data(){
			return {
				hour: 0,
                minute: 0,
                second: 0,
				timezone_label: 'GMT',
                timezone: '',
                timerId: null
            }
        },
        computed: {
		    ...mapGetters({
                systemTimezone: 'timezone'
            })
        },
        watch: {
		    tz(newTz){
		    	this.timezone = newTz;
            }
        },
        methods: {
		    setCurrentTime(){
		    	let currentDate = this.$date().tz(this.timezone);
                this.hour = currentDate.format('HH');
                this.minute = currentDate.format('mm');
                this.second = currentDate.format('ss');
                this.timezone_label = currentDate.format('Z');
            }
        },
        created(){
			this.timezone = this.tz ? this.tz : this.systemTimezone;
            this.timerId = setInterval(this.setCurrentTime, 1000);
        },
        beforeDestroy() {
			if(this.timerId){
				clearInterval(this.timerId)
            }
		}
	}
</script>
